# Class MolstarActionManager<P, L>

#### Type Parameters

- #### P

- #### L

#### Hierarchy

- MolstarActionManager

#### Implements

- ViewerActionManagerInterface<LoadMolstarInterface<P, L>, L>

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:65

#####
Index

### Constructors

constructor

### Properties

innerReprChangeFlag
innerSelectionFlag
loadingFlag
modelMapManager
viewer

### Methods

cameraFocus
changeComponentDisplay
clear
clearFocus
clearSelection
colorComponent
createComponent
displayComponent
exportLoadedStructures
focusPositions
focusRange
getComponentDisplay
getComponentSet
isComponent
load
removeComponent
removeStructure
resetCamera
select
selectMultipleRanges
selectRange
selectSet
setFocus

## Constructors

### constructor

- new MolstarActionManager<P, L>(config): MolstarActionManager<P, L>

- #### Type Parameters

  - #### P

  - #### L

  #### Parameters

  - ##### config: {
    innerReprChangeFlag: DataContainer<boolean>;
    innerSelectionFlag: DataContainer<boolean>;
    loadingFlag: DataContainer<boolean>;
    modelMapManager: ViewerModelMapManagerInterface<LoadMolstarInterface<P, L>, L>;
    viewer: Viewer;
    }

    - ##### innerReprChangeFlag: DataContainer<boolean>

    - ##### innerSelectionFlag: DataContainer<boolean>

    - ##### loadingFlag: DataContainer<boolean>

    - ##### modelMapManager: ViewerModelMapManagerInterface<LoadMolstarInterface<P, L>, L>

    - ##### viewer: Viewer

  #### Returns MolstarActionManager<P, L>

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:74

## Properties

### `Private` `Readonly` innerReprChangeFlag

innerReprChangeFlag: DataContainer<boolean>

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:70

### `Private` `Readonly` innerSelectionFlag

innerSelectionFlag: DataContainer<boolean>

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:69

### `Private` `Readonly` loadingFlag

loadingFlag: DataContainer<boolean>

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:72

### `Private` `Readonly` modelMapManager

modelMapManager: ViewerModelMapManagerInterface<LoadMolstarInterface<P, L>, L>

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:71

### `Private` `Readonly` viewer

viewer: Viewer

- Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:67

## Methods

### cameraFocus

- cameraFocus(modelId, labelAsymId, positions, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### positions: number[]

  - ##### `Optional` operatorName: string

  #### Returns void

  Implementation of ViewerActionManagerInterface.cameraFocus

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:184
- cameraFocus(modelId, labelAsymId, begin, end, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### `Optional` operatorName: string

  #### Returns void

  Implementation of ViewerActionManagerInterface.cameraFocus

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:185

### `Private` changeComponentDisplay

- changeComponentDisplay(componentLabel, visibilityFlag): void

- #### Parameters

  - ##### componentLabel: string

  - ##### visibilityFlag: boolean

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:293

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.clear

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:160

### clearFocus

- clearFocus(): void

- #### Returns void

  Implementation of ViewerActionManagerInterface.clearFocus

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:180

### clearSelection

- clearSelection(mode, option?): void

- #### Parameters

  - ##### mode: "select" | "hover"

  - ##### `Optional` option: SaguaroChain

  #### Returns void

  Implementation of ViewerActionManagerInterface.clearSelection

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:164

### colorComponent

- colorComponent(componentLabel, color): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### color: "uniform" | "occupancy" | "element-index" | "element-symbol" | "shape-group" | "uncertainty" | "atom-id" | "carbohydrate-symbol" | "chain-id" | "entity-id" | "entity-source" | "model-index" | "structure-index" | "molecule-type" | "secondary-structure" | "operator-name" | "unit-index" | "residue-name" | "cartoon" | "hydrophobicity" | "illustrative" | "operator-hkl" | "partial-charge" | "polymer-id" | "polymer-index" | "sequence-id" | "trajectory-index" | "volume-segment" | "volume-value" | "external-volume"

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.colorComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:252

### createComponent

- createComponent(componentLabel, modelId, labelAsymId, begin, end, representationType, operatorName?): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  - ##### `Optional` operatorName: string

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:218
- createComponent(componentLabel, modelId, labelAsymId, representationType, operatorName?): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  - ##### `Optional` operatorName: string

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:219
- createComponent(componentLabel, residues, representationType): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### residues: SaguaroPosition[]

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:220
- createComponent(componentLabel, residues, representationType): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### residues: SaguaroRange[]

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:221

### displayComponent

- displayComponent(componentLabel): boolean

- #### Parameters

  - ##### componentLabel: string

  #### Returns boolean

  Implementation of ViewerActionManagerInterface.displayComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:285
- displayComponent(componentLabel, visibilityFlag): void

- #### Parameters

  - ##### componentLabel: string

  - ##### visibilityFlag: boolean

  #### Returns void

  Implementation of ViewerActionManagerInterface.displayComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:286

### exportLoadedStructures

- exportLoadedStructures(): Promise<void>

- #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.exportLoadedStructures

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:322

### `Private` focusPositions

- focusPositions(modelId, labelAsymId, positions, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### positions: number[]

  - ##### `Optional` operatorName: string

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:200

### `Private` focusRange

- focusRange(modelId, labelAsymId, begin, end, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### `Optional` operatorName: string

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:193

### `Private` getComponentDisplay

- getComponentDisplay(componentLabel): undefined | boolean

- #### Parameters

  - ##### componentLabel: string

  #### Returns undefined | boolean

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:307

### getComponentSet

- getComponentSet(): Set<string>

- #### Returns Set<string>

  Implementation of ViewerActionManagerInterface.getComponentSet

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:263

### isComponent

- isComponent(componentLabel): boolean

- #### Parameters

  - ##### componentLabel: string

  #### Returns boolean

  Implementation of ViewerActionManagerInterface.isComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:241

### load

- load(loadConfig): Promise<undefined | L>

- #### Parameters

  - ##### loadConfig: LoadMolstarInterface<P, L>

  #### Returns Promise<undefined | L>

  Implementation of ViewerActionManagerInterface.load

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:82
- load(loadConfig): Promise<(undefined | L)[]>

- #### Parameters

  - ##### loadConfig: LoadMolstarInterface<P, L>[]

  #### Returns Promise<(undefined | L)[]>

  Implementation of ViewerActionManagerInterface.load

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:83

### removeComponent

- removeComponent(componentLabel?): Promise<void>

- #### Parameters

  - ##### `Optional` componentLabel: string

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.removeComponent

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:277

### removeStructure

- removeStructure(loadConfig): Promise<void>

- #### Parameters

  - ##### loadConfig: LoadMolstarInterface<P, L> | LoadMolstarInterface<P, L>[]

  #### Returns Promise<void>

  Implementation of ViewerActionManagerInterface.removeStructure

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:111

### resetCamera

- resetCamera(): void

- #### Returns void

  Implementation of ViewerActionManagerInterface.resetCamera

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:318

### select

- select(modelId, labelAsymId, begin, end, mode, operation, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  - ##### `Optional` operatorName: string

  #### Returns void

  Implementation of ViewerActionManagerInterface.select

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:126
- select(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroPosition[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  Implementation of ViewerActionManagerInterface.select

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:127
- select(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroRange[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  Implementation of ViewerActionManagerInterface.select

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:128

### `Private` selectMultipleRanges

- selectMultipleRanges(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroRange[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:152

### `Private` selectRange

- selectRange(modelId, labelAsymId, begin, end, mode, operation, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  - ##### `Optional` operatorName: string

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:138

### `Private` selectSet

- selectSet(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroPosition[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:145

### setFocus

- setFocus(modelId, labelAsymId, begin, end, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### `Optional` operatorName: string

  #### Returns void

  Implementation of ViewerActionManagerInterface.setFocus

  - Defined in src/RcsbFvStructure/StructureViewers/MolstarViewer/MolstarActionManager.ts:176

Generated using TypeDoc